---------------------------
--- Core Addon Creation ---
---------------------------
local tomQuest2 = LibStub("AceAddon-3.0"):NewAddon("tomQuest2", "AceEvent-3.0", "AceTimer-3.0", "AceSerializer-3.0", "AceHook-3.0", "AceBucket-3.0")
tomQuest2.cbh = LibStub("CallbackHandler-1.0"):New(tomQuest2)

-----------------------
--- Library loading ---
-----------------------
local LC = LibStub("AceLocale-3.0"):GetLocale("tomQuest2-Core")
local BC = LibStub("LibBabble-Class-3.0"):GetLookupTable()
local LibTourist = LibStub("LibTourist-3.0")

--------------------------------------
--- Copy global functions to local ---
--------------------------------------
local pairs, next, type, GetTime = pairs, next, type, GetTime
local tonumber, format, lower, upper, gsub, strtrim, find, match = tonumber, string.format, string.lower, string.upper, string.gsub, strtrim, string.find, string.match
local GetDailyQuestsCompleted, GetQuestLink, GetQuestGreenRange, QuestDifficultyColor = GetDailyQuestsCompleted, GetQuestLink, GetQuestGreenRange, QuestDifficultyColor
local GetQuestLogLeaderBoard, GetQuestLogQuestText, GetQuestLogPushable = GetQuestLogLeaderBoard, GetQuestLogQuestText, GetQuestLogPushable
local GetQuestLogSelection, SelectQuestLogEntry, QuestLog_SetSelection = GetQuestLogSelection, SelectQuestLogEntry, QuestLog_SetSelection
local GetQuestLogRewardTalents, GetQuestLogRewardMoney, GetQuestLogRewardHonor = GetQuestLogRewardTalents, GetQuestLogRewardMoney, GetQuestLogRewardHonor
local GetQuestLogRewardSpell, GetQuestLogRewardTitle, GetQuestLogRewardInfo = GetQuestLogRewardSpell, GetQuestLogRewardTitle, GetQuestLogRewardInfo
local GetQuestLogChoiceInfo, GetQuestLogItemLink, GetQuestLogTitle = GetQuestLogChoiceInfo, GetQuestLogItemLink, GetQuestLogTitle
local GetNumQuestLogEntries, GetNumQuestLeaderBoards = GetNumQuestLogEntries, GetNumQuestLeaderBoards
local GetNumQuestLogRewards, GetNumQuestLogChoices = GetNumQuestLogRewards, GetNumQuestLogChoices
local GetNumPartyMembers, InCombatLockdown = GetNumPartyMembers, InCombatLockdown
local GetQuestLogSpecialItemInfo, UseQuestLogSpecialItem = GetQuestLogSpecialItemInfo, UseQuestLogSpecialItem
local FauxScrollFrame_GetOffset, FauxScrollFrame_SetOffset = FauxScrollFrame_GetOffset, FauxScrollFrame_SetOffset
local QuestLogListScrollFrame, QuestLogListScrollFrameScrollBar = QuestLogListScrollFrame, QuestLogListScrollFrameScrollBar
local CreateFrame, HideUIPanel, ShowUIPanel = CreateFrame, HideUIPanel, ShowUIPanel
local UnitName, UnitClass, UnitLevel, UnitFactionGroup, UnitAffectingCombat = UnitName, UnitClass, UnitLevel, UnitFactionGroup, UnitAffectingCombat
local GetMacroIndexByName, CreateMacro, EditMacro, PickupMacro = GetMacroIndexByName, CreateMacro, EditMacro, PickupMacro
local GetItemQualityColor, GetItemIcon, GetItemInfo, GetItemSpell = GetItemQualityColor, GetItemIcon, GetItemInfo, GetItemSpell
local GetContainerNumSlots, GetInventorySlotInfo, GetContainerItemLink, GetInventoryItemLink = GetContainerNumSlots, GetInventorySlotInfo, GetContainerItemLink, GetInventoryItemLink

-----------------
--- variables ---
-----------------
local _
local prdb, dbVersion, lastCompatibleDB = nil, 3, 1
tomQuest2.playerName, tomQuest2.playerLevel, _, tomQuest2.playerClass = UnitName("player"), UnitLevel("player"), UnitClass("player")
tomQuest2.partyZone = LC["PARTYQUESTSZONE"]
tomQuest2.numPartyMembers, tomQuest2.numEntries, tomQuest2.numQuests, tomQuest2.numCompletedQuests, tomQuest2.numCompletedDailyQuests = 0, 0, 0, 0, 0
tomQuest2.party, tomQuest2.quests, tomQuest2.questsObjectives, tomQuest2.questsItems, tomQuest2.questsMobs, tomQuest2.questsMobsItems, tomQuest2.questsByZone = {}, {}, {}, {}, {}, {}, {}
tomQuest2.questsIdToUid, tomQuest2.questsTitleToUid, tomQuest2.itemStartingQuest, tomQuest2.usableQuestItems = {}, {}, {}, {}
tomQuest2.numTQ_PlQC, tomQuest2.numTQ_PaQC, tomQuest2.numTQ_PlQC_BML, tomQuest2.numTQ_PaQC_BML, tomQuest2.numItemsStartingQuest, tomQuest2.numUsableQuestItems = 0, 0, 0, 0, 0, 0
local localClass = BC[lower(tomQuest2.playerClass):gsub("^%l", upper)]
local questLogUpdatePending, questLogNeedUpdate, firstRun = false, false, true
local pkstring
local objectsPattern = '^' .. QUEST_OBJECTS_FOUND:gsub('(%%%d?$?.)', '(.+)') .. '$'
local monstersPattern = '^' .. QUEST_MONSTERS_KILLED:gsub('(%%%d?$?.)', '(.+)') .. '$'
local factionPattern = '^' .. QUEST_FACTION_NEEDED:gsub('(%%%d?$?.)', '(.+)') .. '$'
local playersPattern = '^'.. QUEST_PLAYERS_KILLED:gsub('(%%%d?$?.)', '(.+)') .. '$'
local DUNGEON, HEROIC = LFG_TYPE_DUNGEON, DUNGEON_DIFFICULTY2
local collapsedHeader = {}
local abandoning = true
local ITEM_SPELL_TRIGGER_ONUSE = ITEM_SPELL_TRIGGER_ONUSE
local ITEM_STARTS_QUEST = ITEM_STARTS_QUEST
local reactions = {
	[FACTION_STANDING_LABEL1] = 1, [FACTION_STANDING_LABEL1_FEMALE] = 1,
	[FACTION_STANDING_LABEL2] = 2, [FACTION_STANDING_LABEL2_FEMALE] = 2,
	[FACTION_STANDING_LABEL3] = 3, [FACTION_STANDING_LABEL3_FEMALE] = 3,
	[FACTION_STANDING_LABEL4] = 4, [FACTION_STANDING_LABEL4_FEMALE] = 4,
	[FACTION_STANDING_LABEL5] = 5, [FACTION_STANDING_LABEL5_FEMALE] = 5,
	[FACTION_STANDING_LABEL6] = 6, [FACTION_STANDING_LABEL6_FEMALE] = 6,
	[FACTION_STANDING_LABEL7] = 7, [FACTION_STANDING_LABEL7_FEMALE] = 7,
	[FACTION_STANDING_LABEL8] = 8, [FACTION_STANDING_LABEL8_FEMALE] = 8,
}
local items, itemsTimeStamp = {}, {}
local currentItemMacro, currentUidMacro = nil, nil
local tags = {[ELITE] = "elite", [GROUP] = "group", [PVP] = "pvp", [RAID] = "raid", [DUNGEON] = "dungeon", [HEROIC] = "heroic", [DAILY] = "daily"}
local bagList  = {[0] = true, [1] = true, [2] = true, [3] = true, [4] = true}
local inventorySlot, inventorySlotId = { "HeadSlot", "NeckSlot", "ShoulderSlot", "BackSlot", "ChestSlot", "ShirtSlot", "TabardSlot", "WristSlot", "HandsSlot", "WaistSlot", "LegsSlot", "FeetSlot", "Finger0Slot", "Finger1Slot", "Trinket0Slot", "Trinket1Slot", "MainHandSlot", "SecondaryHandSlot", "RangedSlot", "AmmoSlot"}, {}
local scanTooltipTQ2 = CreateFrame( "GameTooltip", "scanTooltipTQ2", nil, "GameToolTipTemplate")
scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")
local moduleState = {}

----------------------
-- Table recycling ---
----------------------
local tablePool = {}
setmetatable(tablePool, {__mode = "kv"})

local function new()
	local t = next(tablePool) or {}
	tablePool[t] = nil
	return t
end

local function del(t)
	if type(t) == "table" then
		for k, v in pairs(t) do
			if type(v) == "table" then
				v = del(v)
			end
			t[k] = nil
		end
		t[true] = true
		t[true] = nil
		setmetatable(t, nil)
		tablePool[t] = true
	end
	return nil
end

--------------------
--- Rarity Color ---
--------------------
local rarityColor = {}
for rarity = 0, 6 do
	local r, g, b = GetItemQualityColor(rarity)
	rarityColor[rarity] = format("%02x%02x%02x", r*255, g*255, b*255)
end

--------------------------
--- Status Computation ---
--------------------------
local function computeQuestStatus(uid)
	tomQuest2.quests[uid].pqStatus = ""
	local partyComplete, playerComplete = tomQuest2.quests[uid].partyComplete, tomQuest2.quests[uid].playerComplete
	local totalCompleted, numPlayers = 0, 0
	for partyName, completed in pairs(tomQuest2.quests[uid].complete) do
		if partyName ~= tomQuest2.playerName and (completed == 1 or completed == -1) then
			numPlayers, totalCompleted = numPlayers + 1, totalCompleted + completed
			if numPlayers > 1 then
				tomQuest2.quests[uid].pqStatus = format("%s, |cff%s%s|r: %s",tomQuest2.quests[uid].pqStatus, tomQuest2.party[partyName].color or "ffffff", partyName:sub(1, 3), completed == 1 and LC["Finished"] or LC["Failed"])
			else
				tomQuest2.quests[uid].pqStatus = format("|cff%s%s|r: %s", tomQuest2.party[partyName].color or "ffffff", partyName:sub(1, 3), completed == 1 and LC["Finished"] or LC["Failed"])
			end
		end
	end
	if tomQuest2.quests[uid].complete[tomQuest2.playerName] and (tomQuest2.quests[uid].complete[tomQuest2.playerName] == 1 or tomQuest2.quests[uid].complete[tomQuest2.playerName] == -1) then
		numPlayers, totalCompleted = numPlayers + 1, totalCompleted + tomQuest2.quests[uid].complete[tomQuest2.playerName]
		if tomQuest2.quests[uid].complete[tomQuest2.playerName] == 1 then
			tomQuest2.quests[uid].playerComplete = 1
		else
			tomQuest2.quests[uid].playerComplete = 0
		end
		if numPlayers > 1 then
			tomQuest2.quests[uid].pqStatus = format("%s, %s", tomQuest2.quests[uid].pqStatus, tomQuest2.quests[uid].complete[tomQuest2.playerName] == 1 and LC["Finished"] or LC["Failed"])
		else
			tomQuest2.quests[uid].pqStatus = format("%s", tomQuest2.quests[uid].complete[tomQuest2.playerName] == 1 and LC["Finished"] or LC["Failed"])
		end
	end
	if totalCompleted == tomQuest2.quests[uid].playersOnQuest then
		tomQuest2.quests[uid].partyComplete = 1
	else
		tomQuest2.quests[uid].partyComplete = 0
	end
	if tomQuest2.quests[uid].tracked == 1 then
		if tomQuest2.quests[uid].complete[tomQuest2.playerName] then
			tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PlQC = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PlQC + tomQuest2.quests[uid].playerComplete - playerComplete
			tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PaQC = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PaQC + tomQuest2.quests[uid].partyComplete - partyComplete
			tomQuest2.numTQ_PlQC = tomQuest2.numTQ_PlQC + tomQuest2.quests[uid].playerComplete - playerComplete
			tomQuest2.numTQ_PaQC = tomQuest2.numTQ_PaQC + tomQuest2.quests[uid].partyComplete - partyComplete
			if tomQuest2.quests[uid].weightedLevel - tomQuest2.playerLevel <= tonumber(prdb.quests.maxLevelDiff) then
				tomQuest2.numTQ_PlQC_BML = tomQuest2.numTQ_PlQC_BML + tomQuest2.quests[uid].playerComplete - playerComplete
				tomQuest2.numTQ_PaQC_BML = tomQuest2.numTQ_PaQC_BML + tomQuest2.quests[uid].partyComplete - partyComplete
			end
		else
			tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_PaQC = tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_PaQC + tomQuest2.quests[uid].partyComplete - partyComplete
			tomQuest2.numTQ_PaQC = tomQuest2.numTQ_PaQC + tomQuest2.quests[uid].partyComplete - partyComplete
			if tomQuest2.quests[uid].weightedLevel - tomQuest2.playerLevel <= tonumber(prdb.quests.maxLevelDiff) then
				tomQuest2.numTQ_PaQC_BML = tomQuest2.numTQ_PaQC_BML + tomQuest2.quests[uid].partyComplete - partyComplete
			end
		end
	end
end

local function computeQuestObjectiveStatus(uid, objective)
	tomQuest2.questsObjectives[uid][objective].qoStatus = ""
	local totalGot, numPlayers = 0, 0
	local pGot, pNGot
	for partyName, qoData in pairs(tomQuest2.questsObjectives[uid][objective].got) do
		local got, nGot= qoData:match("^(.-)~(%d-)$")
		nGot = tonumber(nGot)
		if partyName ~= tomQuest2.playerName then
			numPlayers, totalGot = numPlayers + 1, totalGot + nGot
			if numPlayers > 1 then
				tomQuest2.questsObjectives[uid][objective].qoStatus = format("%s, |cff%s%s|r: |cff%s%s|r",tomQuest2.questsObjectives[uid][objective].qoStatus, tomQuest2.party[partyName].color, partyName:sub(1,3), tomQuest2:getColorFromCompletionHEX(nGot / tomQuest2.questsObjectives[uid][objective].nNeed), nGot == tomQuest2.questsObjectives[uid][objective].nNeed and LC["d"] or got)
				tomQuest2.questsObjectives[uid][objective].qoStatusNC = format("%s, |cff%s%s|r: %s",tomQuest2.questsObjectives[uid][objective].qoStatusNC, tomQuest2.party[partyName].color, partyName:sub(1,3), nGot == tomQuest2.questsObjectives[uid][objective].nNeed and LC["d"] or got)
			else
				tomQuest2.questsObjectives[uid][objective].qoStatus = format("|cff%s%s|r: |cff%s%s|r", tomQuest2.party[partyName].color, partyName:sub(1,3), tomQuest2:getColorFromCompletionHEX(nGot / tomQuest2.questsObjectives[uid][objective].nNeed), nGot == tomQuest2.questsObjectives[uid][objective].nNeed and LC["d"] or got)
				tomQuest2.questsObjectives[uid][objective].qoStatusNC = format("|cff%s%s|r: %s", tomQuest2.party[partyName].color, partyName:sub(1,3), nGot == tomQuest2.questsObjectives[uid][objective].nNeed and LC["d"] or got)
			end
		else
			pGot, pNGot = got, nGot
		end
	end
	if pNGot then
		numPlayers, totalGot = numPlayers + 1, totalGot + pNGot
		if numPlayers > 1 then
			tomQuest2.questsObjectives[uid][objective].qoStatus = format("%s, |cff%s%s|r", tomQuest2.questsObjectives[uid][objective].qoStatus, tomQuest2:getColorFromCompletionHEX(pNGot/tomQuest2.questsObjectives[uid][objective].nNeed), pNGot == tomQuest2.questsObjectives[uid][objective].nNeed and LC["d"] or pGot)
			tomQuest2.questsObjectives[uid][objective].qoStatusNC = format("%s, %s", tomQuest2.questsObjectives[uid][objective].qoStatusNC, pNGot == tomQuest2.questsObjectives[uid][objective].nNeed and LC["d"] or pGot)
		else
			tomQuest2.questsObjectives[uid][objective].qoStatus = format("|cff%s%s|r", tomQuest2:getColorFromCompletionHEX(pNGot/tomQuest2.questsObjectives[uid][objective].nNeed), pNGot == tomQuest2.questsObjectives[uid][objective].nNeed and LC["d"] or pGot)
			tomQuest2.questsObjectives[uid][objective].qoStatusNC = pNGot == tomQuest2.questsObjectives[uid][objective].nNeed and LC["d"] or pGot
		end
		if pNGot == tomQuest2.questsObjectives[uid][objective].nNeed then
			tomQuest2.questsObjectives[uid][objective].playerComplete = 1
		else
			tomQuest2.questsObjectives[uid][objective].playerComplete = 0
		end
	end
	if totalGot == tomQuest2.quests[uid].playersOnQuest * tomQuest2.questsObjectives[uid][objective].nNeed then
		tomQuest2.questsObjectives[uid][objective].partyComplete = 1
	else
		tomQuest2.questsObjectives[uid][objective].partyComplete = 0
	end
	tomQuest2.questsObjectives[uid][objective].qoColor = tomQuest2:getColorFromCompletionHEX(totalGot/ (tomQuest2.quests[uid].playersOnQuest * tomQuest2.questsObjectives[uid][objective].nNeed))
	tomQuest2.questsObjectives[uid][objective].qoStatus = format("%s/|cff%s%s|r", tomQuest2.questsObjectives[uid][objective].qoStatus, tomQuest2.questsObjectives[uid][objective].qoColor, tomQuest2.questsObjectives[uid][objective].need)
	tomQuest2.questsObjectives[uid][objective].qoStatusNC = format("%s/%s", tomQuest2.questsObjectives[uid][objective].qoStatusNC, tomQuest2.questsObjectives[uid][objective].need)
end

-------------------
--- Class Color ---
-------------------
tomQuest2.classColors = {}
for class, color in pairs(CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS) do
	tomQuest2.classColors[class] = format("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
end
local playerColor = tomQuest2.classColors[tomQuest2.playerClass]

local function updateClassColors()
	for class, color in pairs(CUSTOM_CLASS_COLORS) do
		tomQuest2.classColors[class] = format("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
	end
	if tomQuest2.classColors[tomQuest2.playerClass] ~= playerColor then
		playerColor = tomQuest2.classColors[tomQuest2.playerClass]
		for zone in pairs(tomQuest2.questsByZone) do
			if zone == localClass then
				tomQuest2.questsByZone[zone].color = playerColor
				tomQuest2.cbh:Fire("updateQuestsTooltip")
			end
		end
	end
	if tomQuest2.party then
		local colorUpdated = false
		for playerName, pData in pairs(tomQuest2.party) do
			if pData.color ~= tomQuest2.classColors[pData.class] then
				tomQuest2.party[playerName].color = tomQuest2.classColors[pData.class]
				colorUpdated = true
			end
		end
		if colorUpdated == true then
			for uid, qData in pairs(tomQuest2.quests) do
				computeQuestStatus(uid)
				if qData.numObjectives > 0 then
					for objective in pairs(tomQuest2.questsObjectives[uid]) do
						computeQuestObjectiveStatus(uid, objective)
					end
				end
			end
			tomQuest2.cbh:Fire("updateQuestsTooltip")
		end
	end
end

-----------------------
--- Default profile ---
-----------------------
local defaults = {
	profile = {
		modules = {
			dailyTooltip = true,
			notifications = true,
			informations = true,
			questsTooltip = true,
			questsTracker = true,
			soundNotifications = true,
			syncParty = true,
			tagQuestGivers = true,
			tagQuestLog = true,
			tooltips = true,
			announce = false,
			achievementTracker = true,
			questsInfo = true,
		},
		raidModules = {
			enabled = true,
			dailyTooltip = "inRaidInstance",
			notifications = "inRaidInstance",
			informations = "enabled",
			questsTooltip = "enabled",
			questsTracker = "inRaidInstance",
			soundNotifications = "enabled",
			syncParty = "inRaidInstance",
			tagQuestGivers = "enabled",
			tagQuestLog = "enabled",
			tooltips = "inRaidInstance",
			announce = "inRaidInstance",
			achievementTracker = "enabled",
			questsInfo = "enabled",
		},
		quests = {
			hideDefaultBlizTracker = true,
			maxLevelDiff = 3, eliteAddLevel = 3, groupAddLevel = 1,	dungeonAddLevel = 2, heroicAddLevel = 3,
			elite = '+', group = 'g', pvp = 'p', raid = 'r', dungeon = 'd',	heroic = 'd+', daily = "\226\128\162",
			customColorMode = true,
			rj0 = 1, gj0 = 0, bj0 = 0,
			ri1 = 0, rj1 = 1, gi1 = 2, gj1 = 0,	bi1 = 0, bj1 = 0,
			ri2 = -2, rj2 = 2, gi2 = 0, gj2 = 1, bi2 = 0, bj2 = 0,
			rj3 = 0, gj3 = 1, bj3 = 0,
		},
	},
}

----------------------
--- Initialization ---
----------------------
function tomQuest2:Print(text)
	if text then
		DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99tomQuest2|r: "..text)
	end
end

tomQuest2:SetDefaultModuleState(false)
function tomQuest2:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("tomQuest2DB", defaults, "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", "Refresh")
	self.db.RegisterCallback(self, "OnProfileCopied", "Refresh")
	self.db.RegisterCallback(self, "OnProfileReset", "Refresh")
	prdb = self.db.profile
	if prdb.modules["questsTracker"] then
		SetCVar("autoQuestWatch", 0)
		SetCVar("autoQuestProgress", 0)
	else
		SetCVar("autoQuestWatch", 1)
		SetCVar("autoQuestProgress", 1)
	end
	SetCVar("advancedWatchFrame", 1)
	if prdb.version and prdb.version < lastCompatibleDB then
		self.db:ResetDB()
		tomQuest2:Refresh()
	elseif prdb.version == 2 then
		tomQuest2.cbh:Fire("updateDBtoV3")
	end
	prdb.version = dbVersion
	self:SetupOptions()
	local faction = UnitFactionGroup("player")
	if faction == "Alliance" then
		pkstring = LC["Alliance player killed"]
	else
		pkstring = LC["Horde player killed"]
	end
	for k, v in pairs(inventorySlot) do
		local slotId = GetInventorySlotInfo(v)
		inventorySlotId[slotId] = true
	end
	self:RegisterEvent("QUEST_LOG_UPDATE")
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "inCombat")
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "inCombat")
	if prdb.raidModules.enabled then
		self:RegisterEvent("RAID_ROSTER_UPDATE", "checkRaid")
		self:RegisterEvent("PLAYER_ENTERING_WORLD", "checkRaid")
	end
end

function tomQuest2:OnEnable()
	if CUSTOM_CLASS_COLORS then
		CUSTOM_CLASS_COLORS:RegisterCallback(updateClassColors)
	end
	self:SecureHook("AbandonQuest")
	self:SecureHook("WatchFrame_Update")
	if prdb.quests.hideDefaultBlizTracker then
		WATCHFRAME_LINEHEIGHT, WATCHFRAME_LINEHEIGHT_WITHICON , WATCHFRAME_QUESTTIMER_HEIGHT, WATCHFRAME_QUEST_WITH_ITEM_HEIGHT = 0, 0, 0, 0
		WATCHFRAME_INITIAL_OFFSET, WATCHFRAME_TYPE_OFFSET, WATCHFRAME_QUEST_OFFSET, WATCHFRAMELINES_YOFFSET = 0, 0, 0, 0
		WATCHFRAMELINES_FONTHEIGHT, WATCHFRAMELINES_FONTSPACING = 0, 0
		WATCHFRAME_MAXQUESTS, WATCHFRAME_MAXACHIEVEMENTS, MAX_WATCHABLE_QUESTS = 100, 100, 100
		WatchFrame:Hide()
		WatchFrameTitleButton:Hide()
		WatchFrameLines:Hide()
		WatchFrame:SetUserPlaced(true)
		WatchFrame:SetPoint("TOP", "UIParent", "TOP")
	end
	WATCHFRAME_MAXQUESTS = 100
	WATCHFRAME_MAXACHIEVEMENTS = 100
	MAX_WATCHABLE_QUESTS = 100
end

function tomQuest2:Refresh()
	prdb = self.db.profile
	prdb.version = dbVersion
	for k, v in self:IterateModules() do
		if self:getModuleEnabled(k) and not v:IsEnabled() then
			self:EnableModule(k)
		elseif not self:getModuleEnabled(k) and v:IsEnabled() then
			self:DisableModule(k)
		end
		if v.Refresh and type(v.Refresh) == "function" then
			v:Refresh()
		end
	end
	tomQuest2:computeQuestTag()
	tomQuest2:computeQuestsObjectivesStatus()
end

function tomQuest2:getModuleEnabled(module)
	return prdb.modules[module]
end

function tomQuest2:setModuleEnabled(module, value)
	local old = prdb.modules[module]
	prdb.modules[module] = value
	moduleState[module] = value
	if old ~= value then
		if value then
			self:EnableModule(module)
			if module == "questsTracker" then
				SetCVar("autoQuestWatch", 0)
				SetCVar("autoQuestProgress", 0)
			end
		else
			self:DisableModule(module)
			if module == "questsTracker" then
				SetCVar("autoQuestWatch", 1)
				SetCVar("autoQuestProgress", 1)
			end
		end
	end
end

function tomQuest2:updateRaidMode(value)
	if value then
		self:RegisterEvent("RAID_ROSTER_UPDATE", "checkRaid")
		self:RegisterEvent("PLAYER_ENTERING_WORLD", "checkRaid")
		tomQuest2:checkRaid()
	else
		self:UnregisterEvent("RAID_ROSTER_UPDATE")
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		for k in tomQuest2:IterateModules() do
			if prdb.modules[k] ~= moduleState[k] then
				tomQuest2:setModuleEnabled(k, prdb.modules[k])
			end
		end 
	end
end

function tomQuest2:checkRaid()
	local inRaid = UnitInRaid("player")
	local _, instanceType = IsInInstance()
	local inRaidInstance
	if instanceType and instanceType == "raid" then
		inRaidInstance = true
	else
		inRaidInstance = nil
	end
	if (inRaid and not tomQuest2.inRaid) or (not inRaid and tomQuest2.inRaid) then
		for k in tomQuest2:IterateModules() do
			if prdb.raidModules[k] == "inRaid" then
				if inRaid and moduleState[k] then
					moduleState[k] = false
					tomQuest2:DisableModule(k)
				elseif not inRaid and not moduleState[k] then
					tomQuest2:EnableModule(k)
				end
			end
		end
	end
	if (inRaidInstance and not tomQuest2.inRaidInstance) or (not inRaidInstance and tomQuest2.inRaidInstance) then
		for k in tomQuest2:IterateModules() do
			if prdb.raidModules[k] == "inRaidInstance" then
				if inRaidInstance and moduleState[k] then
					tomQuest2:DisableModule(k)
				elseif not inRaidInstance and not moduleState[k] then
					tomQuest2:EnableModule(k)
				end
			end
		end
	end
	tomQuest2.inRaid = inRaid
	tomQuest2.inRaidInstance = inRaidInstance
end

------------------------------------
--- Bliz Quest Tracker show hide ---
------------------------------------
function tomQuest2:WatchFrame_Update()
	if prdb.quests.hideDefaultBlizTracker then
		WatchFrame:Hide()
		WatchFrameTitleButton:Hide()
		WatchFrameLines:Hide()
		WATCHFRAME_LINEHEIGHT, WATCHFRAME_LINEHEIGHT_WITHICON , WATCHFRAME_QUESTTIMER_HEIGHT, WATCHFRAME_QUEST_WITH_ITEM_HEIGHT = 0, 0, 0, 0
		WATCHFRAME_INITIAL_OFFSET, WATCHFRAME_TYPE_OFFSET, WATCHFRAME_QUEST_OFFSET, WATCHFRAMELINES_YOFFSET = 0, 0, 0, 0
		WATCHFRAMELINES_FONTHEIGHT, WATCHFRAMELINES_FONTSPACING = 0, 0
		WATCHFRAME_MAXQUESTS, WATCHFRAME_MAXACHIEVEMENTS, MAX_WATCHABLE_QUESTS = 100, 100, 100
	else
		WatchFrame:Show()
		WatchFrameTitleButton:Show()
		WatchFrameLines:Show()
	end
end

function tomQuest2:hideShowDefaultBlizTracker()
	if prdb.quests.hideDefaultBlizTracker then
		WatchFrame:Hide()
		WatchFrameTitleButton:Hide()
		WatchFrameLines:Hide()
		WATCHFRAME_LINEHEIGHT, WATCHFRAME_LINEHEIGHT_WITHICON , WATCHFRAME_QUESTTIMER_HEIGHT, WATCHFRAME_QUEST_WITH_ITEM_HEIGHT = 0, 0, 0, 0
		WATCHFRAME_INITIAL_OFFSET, WATCHFRAME_TYPE_OFFSET, WATCHFRAME_QUEST_OFFSET, WATCHFRAMELINES_YOFFSET = 0, 0, 0, 0
		WATCHFRAMELINES_FONTHEIGHT, WATCHFRAMELINES_FONTSPACING = 0, 0
		WATCHFRAME_MAXQUESTS, WATCHFRAME_MAXACHIEVEMENTS, MAX_WATCHABLE_QUESTS = 100, 100, 100
	else
		WatchFrame:Show()
		WatchFrameTitleButton:Show()
		WatchFrameLines:Show()
		WATCHFRAME_LINEHEIGHT, WATCHFRAME_LINEHEIGHT_WITHICON , WATCHFRAME_QUESTTIMER_HEIGHT, WATCHFRAME_QUEST_WITH_ITEM_HEIGHT = 16, 26, 37, 39
		WATCHFRAME_INITIAL_OFFSET, WATCHFRAME_TYPE_OFFSET, WATCHFRAME_QUEST_OFFSET, WATCHFRAMELINES_YOFFSET = 0, 5, 10, 42
		WATCHFRAMELINES_FONTHEIGHT = WatchFrameLines:GetHeight()
		WATCHFRAMELINES_FONTSPACING = (WATCHFRAME_LINEHEIGHT - WATCHFRAMELINES_FONTHEIGHT) / 2
	end
end

-------------------------
--- Hook AbandonQuest ---
-------------------------
function tomQuest2:AbandonQuest()
	abandoning = true
end

-----------------------
--- Tools Functions ---
-----------------------
local function getDifficultyColor(levelDiff)
	local color
	if ( levelDiff >= 5 ) then
		color = QuestDifficultyColor["impossible"]
	elseif ( levelDiff >= 3 ) then
		color = QuestDifficultyColor["verydifficult"]
	elseif ( levelDiff >= -2 ) then
		color = QuestDifficultyColor["difficult"]
	elseif ( -levelDiff <= GetQuestGreenRange() ) then
		color = QuestDifficultyColor["standard"]
	else
		color = QuestDifficultyColor["trivial"]
	end
	return color
end

local function normalizeColorComponent(component)
	if component > 1 then return 1 elseif component < 0 then return 0 else return component end
end

function tomQuest2:getColorFromCompletionRGB(percent)
	if percent <= 0 then
		return normalizeColorComponent(prdb.quests.rj0), normalizeColorComponent(prdb.quests.gj0), normalizeColorComponent(prdb.quests.bj0)
	elseif percent >= 1 then
		return normalizeColorComponent(prdb.quests.rj3), normalizeColorComponent(prdb.quests.gj3), normalizeColorComponent(prdb.quests.bj3)
	elseif percent <= 0.5 then
		return normalizeColorComponent(prdb.quests.ri1*percent + prdb.quests.rj1), normalizeColorComponent(prdb.quests.gi1*percent + prdb.quests.gj1), normalizeColorComponent(prdb.quests.bi1*percent + prdb.quests.bj1)
	else
		return normalizeColorComponent(prdb.quests.ri2*percent + prdb.quests.rj2), normalizeColorComponent(prdb.quests.gi2*percent + prdb.quests.gj2), normalizeColorComponent(prdb.quests.bi2*percent + prdb.quests.bj2)
	end
end

function tomQuest2:getColorFromCompletionHEX(percent)
	if percent <= 0 then
		return format("%02x%02x%02x", 255*normalizeColorComponent(prdb.quests.rj0), 255*normalizeColorComponent(prdb.quests.gj0), 255*normalizeColorComponent(prdb.quests.bj0))
	elseif percent >= 1 then
		return format("%02x%02x%02x", 255*normalizeColorComponent(prdb.quests.rj3), 255*normalizeColorComponent(prdb.quests.gj3), 255*normalizeColorComponent(prdb.quests.bj3))
	elseif percent <= 0.5 then
		return format("%02x%02x%02x", 255*normalizeColorComponent(prdb.quests.ri1*percent + prdb.quests.rj1), 255*normalizeColorComponent(prdb.quests.gi1*percent + prdb.quests.gj1), 255*normalizeColorComponent(prdb.quests.bi1*percent + prdb.quests.bj1))
	else
		return format("%02x%02x%02x", 255*normalizeColorComponent(prdb.quests.ri2*percent + prdb.quests.rj2), 255*normalizeColorComponent(prdb.quests.gi2*percent + prdb.quests.gj2), 255*normalizeColorComponent(prdb.quests.bi2*percent + prdb.quests.bj2))
	end
end

-----------------------
--- Quests Functions ---
------------------------
function tomQuest2:computeQuestsObjectivesStatus()
	for uid, qoData in pairs (tomQuest2.questsObjectives) do
		for objective in pairs (qoData) do
			computeQuestObjectiveStatus(uid, objective)
		end
	end
	tomQuest2.cbh:Fire("updateQuestsTracker")
	tomQuest2.cbh:Fire("questLogUpdated", true, true)
end

function tomQuest2:addZone(zone)
	tomQuest2.questsByZone[zone] = new()
	if zone == tomQuest2.partyZone then
		tomQuest2.questsByZone[zone].minLevel, tomQuest2.questsByZone[zone].maxLevel, tomQuest2.questsByZone[zone].level = "", "", ""
		tomQuest2.questsByZone[zone].color = "ffffff"
		tomQuest2.questsByZone[zone].zone = true
	elseif zone == localClass then
		tomQuest2.questsByZone[zone].minLevel, tomQuest2.questsByZone[zone].maxLevel, tomQuest2.questsByZone[zone].level = "", "", ""
		tomQuest2.questsByZone[zone].color = playerColor
	else
		tomQuest2.questsByZone[zone].minLevel, tomQuest2.questsByZone[zone].maxLevel = LibTourist:GetLevel(zone)
		if tomQuest2.questsByZone[zone].maxLevel == 0 then
			tomQuest2.questsByZone[zone].level = ""
			tomQuest2.questsByZone[zone].color = "ffffff"
		else
			tomQuest2.questsByZone[zone].level = format("(%s-%s)", tomQuest2.questsByZone[zone].minLevel, tomQuest2.questsByZone[zone].maxLevel)
			local r, g, b = LibTourist:GetLevelColor(zone)
			tomQuest2.questsByZone[zone].color = format("%02x%02x%02x", r*255, g*255, b*255)
			tomQuest2.questsByZone[zone].zone = true
		end
	end
	tomQuest2.questsByZone[zone].numQuests = 0
	tomQuest2.questsByZone[zone].numTQ = 0
	tomQuest2.questsByZone[zone].numTQ_PlQC = 0
	tomQuest2.questsByZone[zone].numTQ_PaQC = 0
	tomQuest2.questsByZone[zone].numTQ_BML = 0
	tomQuest2.questsByZone[zone].numTQ_PlQC_BML = 0
	tomQuest2.questsByZone[zone].numTQ_PaQC_BML = 0
	tomQuest2.questsByZone[zone].quests = new()
end

local function addQuestDetails(uid)
	if tomQuest2.quests[uid].extras then
		return
	else
		local status = true
		SelectQuestLogEntry(tomQuest2.quests[uid].id)
		tomQuest2.quests[uid].specialItemLink, tomQuest2.quests[uid].specialItemIcon = GetQuestLogSpecialItemInfo(tomQuest2.quests[uid].id)
		if tomQuest2.quests[uid].specialItemLink then
			if items[tomQuest2.quests[uid].specialItemLink] and items[tomQuest2.quests[uid].specialItemLink] ~= uid then
				if items[tomQuest2.quests[uid].specialItemLink] == 0 then
					tomQuest2.numItemsStartingQuest = tomQuest2.numItemsStartingQuest - 1
					tomQuest2.itemStartingQuest[tomQuest2.quests[uid].specialItemLink] = del(tomQuest2.itemStartingQuest[tomQuest2.quests[uid].specialItemLink])
				elseif items[tomQuest2.quests[uid].specialItemLink] == -1 then
					tomQuest2.numUsableQuestItems = tomQuest2.numUsableQuestItems - 1
					tomQuest2.usableQuestItems[tomQuest2.quests[uid].specialItemLink] = del(tomQuest2.usableQuestItems[tomQuest2.quests[uid].specialItemLink])
				end
		end
			items[tomQuest2.quests[uid].specialItemLink] = uid
		end
		tomQuest2.quests[uid].sharable = GetQuestLogPushable()

		if not tomQuest2.quests[uid].extraSync then
			tomQuest2.quests[uid].description, tomQuest2.quests[uid].objective = GetQuestLogQuestText()
			tomQuest2.quests[uid].money = GetQuestLogRewardMoney() or 0
			tomQuest2.quests[uid].honor = GetQuestLogRewardHonor() or 0
			tomQuest2.quests[uid].talent = GetQuestLogRewardTalents() or 0
			tomQuest2.quests[uid].titleReward = GetQuestLogRewardTitle() or ""
			tomQuest2.quests[uid].numRewards = GetNumQuestLogRewards() or 0
			tomQuest2.quests[uid].numChoices = GetNumQuestLogChoices() or 0
			tomQuest2.quests[uid].rewardSpellTexture, tomQuest2.quests[uid].rewardSpellName = GetQuestLogRewardSpell()
			tomQuest2.quests[uid].rewardSpellTexture = tomQuest2.quests[uid].rewardSpellTexture or ""
			tomQuest2.quests[uid].rewardSpellName = tomQuest2.quests[uid].rewardSpellName or ""
			if tomQuest2.quests[uid].numRewards > 0 then
				tomQuest2.quests[uid].itemRewards = new()
				for i = 1, tomQuest2.quests[uid].numRewards do
					tomQuest2.quests[uid].itemRewards[i] = new()
					tomQuest2.quests[uid].itemRewards[i].name, tomQuest2.quests[uid].itemRewards[i].texture, tomQuest2.quests[uid].itemRewards[i].numItems, tomQuest2.quests[uid].itemRewards[i].quality, tomQuest2.quests[uid].itemRewards[i].isUsable = GetQuestLogRewardInfo(i)
					tomQuest2.quests[uid].itemRewards[i].link = GetQuestLogItemLink('reward', i)
					if not tomQuest2.quests[uid].itemRewards[i].link then
						status = nil
					elseif not tomQuest2.quests[uid].itemRewards[i].texture then
						tomQuest2.quests[uid].itemRewards[i].texture = GetItemIcon(tomQuest2.quests[uid].itemRewards[i].link)
					end
				end
			end
			if tomQuest2.quests[uid].numChoices > 0 then
				tomQuest2.quests[uid].itemChoices = new()
				for i = 1, tomQuest2.quests[uid].numChoices do
					tomQuest2.quests[uid].itemChoices[i] = new()
					tomQuest2.quests[uid].itemChoices[i].name, tomQuest2.quests[uid].itemChoices[i].texture, tomQuest2.quests[uid].itemChoices[i].numItems, tomQuest2.quests[uid].itemChoices[i].quality, tomQuest2.quests[uid].itemChoices[i].isUsable = GetQuestLogChoiceInfo(i)
					tomQuest2.quests[uid].itemChoices[i].link = GetQuestLogItemLink('choice', i)
					if not tomQuest2.quests[uid].itemChoices[i].link then
						status = nil
					elseif not tomQuest2.quests[uid].itemChoices[i].texture then
						tomQuest2.quests[uid].itemChoices[i].texture = GetItemIcon(tomQuest2.quests[uid].itemChoices[i].link)
					end
				end
			end
		end

		if (tomQuest2.quests[uid].description or tomQuest2.quests[uid].objective) then
			for itemLink, itemData in pairs(items) do
				if itemData and (itemData == 0 or itemData == -1) then
					local itemName, _, itemRarity, _, _, itemType, _, _, _, itemTexture = GetItemInfo(itemLink)
					if (tomQuest2.quests[uid].objective and tomQuest2.quests[uid].objective:find(itemName, 1, true)) or (tomQuest2.quests[uid].description and tomQuest2.quests[uid].description:find(itemName, 1, true)) then
						if itemData == 0 then
							tomQuest2.numItemsStartingQuest = tomQuest2.numItemsStartingQuest - 1
							tomQuest2.itemStartingQuest[itemLink] = del(tomQuest2.itemStartingQuest[itemLink])
						elseif itemData == -1 then
							tomQuest2.numUsableQuestItems = tomQuest2.numUsableQuestItems - 1
							tomQuest2.usableQuestItems[itemLink] = del(tomQuest2.usableQuestItems[itemLink])
						end
						items[itemLink] = uid
						tomQuest2.quests[uid].specialItemLink, tomQuest2.quests[uid].specialItemIcon = itemLink, itemTexture
					end
				end
			end
		else
			status = nil
		end

		if status then
			tomQuest2.quests[uid].extras = true
		else
			tomQuest2.quests[uid].numRewards = 0
			tomQuest2.quests[uid].numChoices = 0
			tomQuest2:ScheduleTimer(addQuestDetails, 0.1, uid)
		end
	end
end

function tomQuest2:addQuest(sender, first, uid, title, level, tag, group, daily, numObjectives, completed, zone, id)
	if not tomQuest2.quests[uid] then
		tomQuest2.quests[uid] = new()
		tomQuest2.quests[uid].playersOnQuest = 0
		tomQuest2.quests[uid].playerComplete = 0
		tomQuest2.quests[uid].partyComplete = 0
		tomQuest2.quests[uid].tracked = 0
		tomQuest2.quests[uid].title = title
		tomQuest2.quests[uid].level = level
		tomQuest2.quests[uid].zone = zone
		tomQuest2.quests[uid].numObjectives = numObjectives
		tomQuest2.quests[uid].complete = new()
		local qc = getDifficultyColor(level - tomQuest2.playerLevel)
		tomQuest2.quests[uid].color = format("%02x%02x%02x", qc.r*255, qc.g*255, qc.b*255)
		tomQuest2.quests[uid].shortTag = tag
		tomQuest2.quests[uid].group = group
		tomQuest2.quests[uid].daily = daily
		if level > 0 or tag ~= "" or group > 0 or daily == 1 then
			tomQuest2.quests[uid].tag = format("[%s%s%s%s]", level or "", tag ~= "" and prdb.quests[tags[tag]] or "", group > 0 and group or "", daily == 1 and (tag ~= DAILY and prdb.quests[tags[DAILY]] or "") or "")
		else
			tomQuest2.quests[uid].tag = ""
		end
		if tag == ELITE and (prdb.quests.eliteAddLevel or 0) > 0 then
			tomQuest2.quests[uid].weightedLevel = (level or 0) + prdb.quests.eliteAddLevel
		elseif tag == GROUP and (prdb.quests.groupAddLevel or 0) > 0 then
			tomQuest2.quests[uid].weightedLevel = (level or 0) + (prdb.quests.groupAddLevel * (tomQuest2.quests[uid].group - (tomQuest2.numPartyMembers or (GetNumPartyMembers() or 0))))
		elseif tag == HEROIC and (prdb.quests.heroicAddLevel or 0) > 0 then
			tomQuest2.quests[uid].weightedLevel = (level or 0) + (prdb.quests.heroicAddLevel * (5 - (tomQuest2.numPartyMembers or (GetNumPartyMembers() or 0))))
		elseif tag == DUNGEON and (prdb.quests.dungeonAddLevel or 0) > 0 then
			tomQuest2.quests[uid].weightedLevel = (level or 0) + (prdb.quests.dungeonAddLevel * (5 - (tomQuest2.numPartyMembers or (GetNumPartyMembers() or 0))))
		else
			tomQuest2.quests[uid].weightedLevel = (level or 0)
		end
		if numObjectives > 0 then
			tomQuest2.questsObjectives[uid] = new()
		end
		if sender ~= tomQuest2.playerName then
			tomQuest2.questsByZone[tomQuest2.partyZone].quests[uid] = true
			tomQuest2.questsByZone[tomQuest2.partyZone].numQuests = tomQuest2.questsByZone[tomQuest2.partyZone].numQuests + 1
		else
			tomQuest2.questsByZone[zone].quests[uid] = true
			tomQuest2.questsByZone[zone].numQuests = tomQuest2.questsByZone[zone].numQuests + 1
			if zone == localClass then
				tomQuest2.quests[uid].class = true
			end
		end
	end
	tomQuest2.quests[uid].complete[sender] = completed
	tomQuest2.quests[uid].playersOnQuest = tomQuest2.quests[uid].playersOnQuest + 1
	if sender == tomQuest2.playerName then
		if tomQuest2.quests[uid].playersOnQuest > 1 then
			tomQuest2.questsByZone[zone].quests[uid] = true
			tomQuest2.questsByZone[zone].numQuests = tomQuest2.questsByZone[zone].numQuests + 1
			tomQuest2.questsByZone[tomQuest2.partyZone].quests[uid] = del(tomQuest2.questsByZone[tomQuest2.partyZone].quests[uid])
			tomQuest2.questsByZone[tomQuest2.partyZone].numQuests = tomQuest2.questsByZone[tomQuest2.partyZone].numQuests - 1
			if tomQuest2.quests[uid].tracked == 1 then
				tomQuest2.questsByZone[zone].numTQ = tomQuest2.questsByZone[zone].numTQ + 1
				tomQuest2.questsByZone[tomQuest2.partyZone].numTQ = tomQuest2.questsByZone[tomQuest2.partyZone].numTQ - 1
			end
			if tomQuest2.questsByZone[tomQuest2.partyZone].numQuests == 0 then
				tomQuest2.questsByZone[tomQuest2.partyZone] = del(tomQuest2.questsByZone[tomQuest2.partyZone])
			end
		end
		tomQuest2.cbh:Fire("addPlayerQuest", first, "q", uid, title, level, tag, group, daily, numObjectives, completed, zone)
	else
		tomQuest2.cbh:Fire("addPartyQuest", nil, nil, uid)
	end
	computeQuestStatus(uid)
end

function tomQuest2:questComplete(sender, first, uid)
	tomQuest2.quests[uid].complete[sender] = 1
	computeQuestStatus(uid)
	if sender == tomQuest2.playerName then
		tomQuest2.cbh:Fire("playerQuestComplete", first, "c", uid)
	else
		tomQuest2.cbh:Fire("partyQuestComplete", nil, nil, uid, sender)
	end
end

function tomQuest2:questFailed(sender, first, uid)
	tomQuest2.quests[uid].complete[sender] = -1
	computeQuestStatus(uid)
	if sender == tomQuest2.playerName then
		tomQuest2.cbh:Fire("playerQuestFailed", first, "f", uid)
	else
		tomQuest2.cbh:Fire("partyQuestFailed", nil, nil, uid, sender)
	end
end

function tomQuest2:addQuestObjective(sender, first, uid, objective, desc, qType, got, need, nGot, nNeed)
	if not tomQuest2.questsObjectives[uid][objective] then
		tomQuest2.questsObjectives[uid][objective] = new()
		tomQuest2.questsObjectives[uid][objective].desc = desc
		tomQuest2.questsObjectives[uid][objective].qType = qType
		tomQuest2.questsObjectives[uid][objective].nNeed = nNeed
		tomQuest2.questsObjectives[uid][objective].need = need
		tomQuest2.questsObjectives[uid][objective].got = new()
		if qType == "object" then
			if not tomQuest2.questsItems[desc] then
				tomQuest2.questsItems[desc] = new()
				tomQuest2.questsItems[desc].numQuests = 0
				tomQuest2.questsItems[desc].quests = new()
			end
			if not tomQuest2.questsItems[desc].quests[uid] then
				tomQuest2.questsItems[desc].numQuests = tomQuest2.questsItems[desc].numQuests + 1
				tomQuest2.questsItems[desc].quests[uid] = objective
			end
			if MobMapDotParentFrame then
				if not MobMap_GetDropItemNameList then
					MobMap_LoadDatabase(7)
				end
				if MobMap_GetDropItemNameList then
					local mobMapDropList = MobMap_GetDropItemNameList(desc)
					if mobMapDropList then
						local mobMapDropChance = MobMap_GetDropChances(mobMapDropList[1])
						for k, v in pairs(mobMapDropChance) do
							if v.mobid and v.mobid ~= 0 then
								local mobName = MobMap_GetMobName(v.mobid)
								if not tomQuest2.questsItems[desc].mobDrop then
									tomQuest2.questsItems[desc].mobDrop = new()
								end
								tomQuest2.questsItems[desc].mobDrop[mobName] = true
								if not tomQuest2.questsMobsItems[mobName] then
									tomQuest2.questsMobsItems[mobName] = new()
									tomQuest2.questsMobsItems[mobName].items = new()
									tomQuest2.questsMobsItems[mobName].numItems = 0
									local zoneId = MobMap_GetMobZone(v.mobid)
									tomQuest2.questsMobsItems[mobName].mobLoc = new()
									local zoneName = "???"
									if zoneId.id ~= nil then
										zoneName = MobMap_GetZoneName(zoneId.id)
									end
									tomQuest2.questsMobsItems[mobName].mobLoc[zoneName] = true
								end
								if not tomQuest2.questsMobsItems[mobName].items[desc] then
									tomQuest2.questsMobsItems[mobName].numItems = tomQuest2.questsMobsItems[mobName].numItems + 1
									tomQuest2.questsMobsItems[mobName].items[desc] = new()
									tomQuest2.questsMobsItems[mobName].items[desc].numQuests = 0
									tomQuest2.questsMobsItems[mobName].items[desc].dropRate = v.chance
									tomQuest2.questsMobsItems[mobName].items[desc].quests = new()
								end
								if not tomQuest2.questsMobsItems[mobName].items[desc].quests[uid] then
									tomQuest2.questsMobsItems[mobName].items[desc].numQuests = tomQuest2.questsMobsItems[mobName].items[desc].numQuests + 1
									tomQuest2.questsMobsItems[mobName].items[desc].quests[uid] = objective
								end
							end
						end
					end
				end
			end
		elseif qType == "monster" then
			if not tomQuest2.questsMobs[desc] then
				tomQuest2.questsMobs[desc] = new()
				tomQuest2.questsMobs[desc].numQuests = 0
				tomQuest2.questsMobs[desc].quests = new()
			end
			if not tomQuest2.questsMobs[desc].quests[uid] then
				tomQuest2.questsMobs[desc].numQuests = tomQuest2.questsMobs[desc].numQuests + 1
				tomQuest2.questsMobs[desc].quests[uid] = objective
			end
		end
	end
	tomQuest2.questsObjectives[uid][objective].got[sender] = format("%s~%d", got, nGot)
	computeQuestObjectiveStatus(uid, objective)
	if sender == tomQuest2.playerName then
		tomQuest2.cbh:Fire("addPlayerQuestObjective", first, "o", uid, objective, desc, qType, got, need, nGot, nNeed)
	else
		tomQuest2.cbh:Fire("addPartyQuestObjective", nil, nil, uid, objective)
	end
end

function tomQuest2:questObjectiveProgress(sender, first, uid, objective, got, nGot)
	tomQuest2.questsObjectives[uid][objective].got[sender] = format("%s~%d", got, nGot)
	computeQuestObjectiveStatus(uid, objective)
	if sender == tomQuest2.playerName then
		tomQuest2.cbh:Fire("playerQuestObjectiveProgress", first, "p", uid, objective, got, nGot)
	else
		tomQuest2.cbh:Fire("partyQuestObjectiveProgress", nil, nil, uid, objective, got, nGot, sender)
	end
end

function tomQuest2:questLost(sender, first, uid, abandoning, message)
	local title = tomQuest2.quests[uid].title
	local updateBag = nil
	if sender == tomQuest2.playerName and tomQuest2.quests[uid].specialItemLink then
		items[tomQuest2.quests[uid].specialItemLink] = nil
		updateBag = true
	end
	tomQuest2.quests[uid].playersOnQuest = tomQuest2.quests[uid].playersOnQuest - 1
	if tomQuest2.quests[uid].numObjectives > 0 then
		for objective, qoData in pairs(tomQuest2.questsObjectives[uid]) do
			tomQuest2.questsObjectives[uid][objective].got[sender] = nil
			if tomQuest2.quests[uid].playersOnQuest == 0 then
				if qoData.qType == "object" then
					if tomQuest2.questsItems[qoData.desc] then
						tomQuest2.questsItems[qoData.desc].quests[uid] = nil
						tomQuest2.questsItems[qoData.desc].numQuests = tomQuest2.questsItems[qoData.desc].numQuests - 1
						if tomQuest2.questsItems[qoData.desc].mobDrop then
							for mobName in pairs(tomQuest2.questsItems[qoData.desc].mobDrop) do
								tomQuest2.questsMobsItems[mobName].items[qoData.desc][uid] = nil
							end
						end
						if tomQuest2.questsItems[qoData.desc].numQuests == 0 then
							if tomQuest2.questsItems[qoData.desc].mobDrop then
								for mobName in pairs(tomQuest2.questsItems[qoData.desc].mobDrop) do
									tomQuest2.questsMobsItems[mobName].items[qoData.desc] = del(tomQuest2.questsMobsItems[mobName].items[qoData.desc])
									tomQuest2.questsMobsItems[mobName].numItems = tomQuest2.questsMobsItems[mobName].numItems - 1
									if tomQuest2.questsMobsItems[mobName].numItems == 0 then
										tomQuest2.questsMobsItems[mobName] = del(tomQuest2.questsMobsItems[mobName])
									end
								end
							end
							tomQuest2.questsItems[qoData.desc] = del(tomQuest2.questsItems[qoData.desc])
						end
					end
				elseif qoData.qType == "monster" then
					tomQuest2.questsMobs[qoData.desc].quests[uid] = nil
					tomQuest2.questsMobs[qoData.desc].numQuests = tomQuest2.questsMobs[qoData.desc].numQuests - 1
					if tomQuest2.questsMobs[qoData.desc].numQuests == 0 then
						tomQuest2.questsMobs[qoData.desc] = del(tomQuest2.questsMobs[qoData.desc])
					end
				end
				tomQuest2.questsObjectives[uid][objective] = del(tomQuest2.questsObjectives[uid][objective])
			else
				computeQuestObjectiveStatus(uid, objective)
			end
		end
	end
	tomQuest2.quests[uid].complete[sender] = nil
	if tomQuest2.quests[uid].playersOnQuest == 0 then
		if sender == tomQuest2.playerName then
			if currentUidMacro == uid then
				tomQuest2:generateSpecialItemMacro()
			end
			tomQuest2.questsTitleToUid[tomQuest2.quests[uid].title] = nil
			tomQuest2.questsIdToUid[tomQuest2.quests[uid].id] = nil
			if tomQuest2.quests[uid].tracked == 1 then
				tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ - 1
				tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PlQC = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PlQC - tomQuest2.quests[uid].playerComplete
				tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PaQC = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PaQC - tomQuest2.quests[uid].partyComplete
				tomQuest2.numTQ_PlQC = tomQuest2.numTQ_PlQC - tomQuest2.quests[uid].playerComplete
				tomQuest2.numTQ_PaQC = tomQuest2.numTQ_PaQC - tomQuest2.quests[uid].partyComplete
				if tomQuest2.quests[uid].weightedLevel - tomQuest2.playerLevel <= tonumber(prdb.quests.maxLevelDiff) then
					tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_BML = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_BML - 1
					tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PlQC_BML = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PlQC_BML - tomQuest2.quests[uid].playerComplete
					tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PaQC_BML = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PaQC_BML - tomQuest2.quests[uid].partyComplete
					tomQuest2.numTQ_PlQC_BML = tomQuest2.numTQ_PlQC_BML - tomQuest2.quests[uid].playerComplete
					tomQuest2.numTQ_PaQC_BML = tomQuest2.numTQ_PaQC_BML - tomQuest2.quests[uid].partyComplete
				end
			end
			tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numQuests = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numQuests - 1
			tomQuest2.questsByZone[tomQuest2.quests[uid].zone].quests[uid] = nil
			if tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numQuests == 0 then
				tomQuest2.questsByZone[tomQuest2.quests[uid].zone] = del(tomQuest2.questsByZone[tomQuest2.quests[uid].zone])
			end
		else
			if tomQuest2.quests[uid].tracked == 1 then
				tomQuest2.questsByZone[tomQuest2.partyZone].numTQ = tomQuest2.questsByZone[tomQuest2.partyZone].numTQ - 1
				tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_PaQC = tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_PaQC - tomQuest2.quests[uid].partyComplete
				tomQuest2.numTQ_PaQC = tomQuest2.numTQ_PaQC - tomQuest2.quests[uid].partyComplete
				if tomQuest2.quests[uid].weightedLevel - tomQuest2.playerLevel <= tonumber(prdb.quests.maxLevelDiff) then
					tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_BML = tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_BML - 1
					tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_PaQC_BML = tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_PaQC_BML - tomQuest2.quests[uid].partyComplete
					tomQuest2.numTQ_PaQC_BML = tomQuest2.numTQ_PaQC_BML - tomQuest2.quests[uid].partyComplete
				end
			end
			tomQuest2.questsByZone[tomQuest2.partyZone].numQuests = tomQuest2.questsByZone[tomQuest2.partyZone].numQuests - 1
			tomQuest2.questsByZone[tomQuest2.partyZone].quests[uid] = nil
			if tomQuest2.questsByZone[tomQuest2.partyZone].numQuests == 0 then
				tomQuest2.questsByZone[tomQuest2.partyZone] = del(tomQuest2.questsByZone[tomQuest2.partyZone])
			end
		end
		if tomQuest2.quests[uid].numObjectives > 0 then
			tomQuest2.questsObjectives[uid] = del(tomQuest2.questsObjectives[uid])
		end
		tomQuest2.quests[uid] = del(tomQuest2.quests[uid])
	else
		if sender == tomQuest2.playerName then
			if currentUidMacro == uid then
				tomQuest2:generateSpecialItemMacro()
			end
			tomQuest2.questsTitleToUid[tomQuest2.quests[uid].title] = nil
			tomQuest2.questsIdToUid[tomQuest2.quests[uid].id] = nil
			tomQuest2.quests[uid].id = nil
			tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numQuests = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numQuests - 1
			tomQuest2.questsByZone[tomQuest2.quests[uid].zone].quests[uid] = nil
			if not tomQuest2.questsByZone[tomQuest2.partyZone] then
				tomQuest2:addZone(tomQuest2.partyZone)
			end
			tomQuest2.questsByZone[tomQuest2.partyZone].numQuests = tomQuest2.questsByZone[tomQuest2.partyZone].numQuests + 1
			tomQuest2.questsByZone[tomQuest2.partyZone].quests[uid] = true
			if tomQuest2.quests[uid].tracked == 1 then
				tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PlQC = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PlQC - tomQuest2.quests[uid].playerComplete
				tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PaQC = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PaQC - tomQuest2.quests[uid].partyComplete
				tomQuest2.numTQ_PlQC = tomQuest2.numTQ_PlQC - tomQuest2.quests[uid].playerComplete
				if tomQuest2.quests[uid].weightedLevel - tomQuest2.playerLevel <= tonumber(prdb.quests.maxLevelDiff) then
					tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_BML = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_BML - 1
					tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PlQC_BML = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PlQC_BML - tomQuest2.quests[uid].playerComplete
					tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PaQC_BML = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ_PaQC_BML - tomQuest2.quests[uid].partyComplete
					tomQuest2.numTQ_PlQC_BML = tomQuest2.numTQ_PlQC_BML - tomQuest2.quests[uid].playerComplete
					tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_BML = tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_BML + 1
					tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_PaQC_BML = tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_PaQC_BML + tomQuest2.quests[uid].partyComplete
				end
				tomQuest2.quests[uid].playerComplete = 0
				tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ = tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numTQ - 1
				tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_PaQC = tomQuest2.questsByZone[tomQuest2.partyZone].numTQ_PaQC + tomQuest2.quests[uid].partyComplete
				tomQuest2.questsByZone[tomQuest2.partyZone].numTQ = tomQuest2.questsByZone[tomQuest2.partyZone].numTQ + 1
			end
			if tomQuest2.questsByZone[tomQuest2.quests[uid].zone].numQuests == 0 then
				tomQuest2.questsByZone[tomQuest2.quests[uid].zone] = del(tomQuest2.questsByZone[tomQuest2.quests[uid].zone])
			end
		end
		computeQuestStatus(uid)
	end
	if sender == tomQuest2.playerName then
		tomQuest2.cbh:Fire("playerQuestLost", first, "l", uid, abandoning)
	elseif message == 1 then
		tomQuest2.cbh:Fire("partyQuestLost", nil, nil, uid, abandoning, title, sender)
	end
	if updateBag then
		tomQuest2:updateBag()
	end
end

function tomQuest2:computeQuestLevel()
	for uid, questData in pairs(tomQuest2.quests) do
		if questData.shortTag == ELITE and prdb.quests.eliteAddLevel > 0 then
			tomQuest2.quests[uid].weightedLevel = (questData.level or 0) + prdb.quests.eliteAddLevel
		elseif questData.shortTag == GROUP and prdb.quests.groupAddLevel > 0 then
			tomQuest2.quests[uid].weightedLevel = (questData.level or 0) + (prdb.quests.groupAddLevel * (tomQuest2.quests[uid].group - (tomQuest2.numPartyMembers or (GetNumPartyMembers() or 0))))
		elseif questData.shortTag == HEROIC and prdb.quests.heroicAddLevel > 0 then
			tomQuest2.quests[uid].weightedLevel = (questData.level or 0) + (prdb.quests.heroicAddLevel * (5 - (tomQuest2.numPartyMembers or (GetNumPartyMembers() or 0))))
		elseif questData.shortTag == DUNGEON and prdb.quests.dungeonAddLevel > 0 then
			tomQuest2.quests[uid].weightedLevel = (questData.level or 0) + (prdb.quests.dungeonAddLevel * (5 - (tomQuest2.numPartyMembers or (GetNumPartyMembers() or 0))))
		else
			tomQuest2.quests[uid].weightedLevel = (questData.level or 0)
		end
	end
	tomQuest2.cbh:Fire("questsWeightedLevelUpdated")
end

function tomQuest2:computeQuestTag()
	for uid, questData in pairs(tomQuest2.quests) do
		if questData.level > 0 or questData.shortTag ~= "" or questData.group > 0 or questData.daily ~= "" then
			tomQuest2.quests[uid].tag = format("[%s%s%s%s]", questData.level or "", questData.shortTag ~= "" and prdb.quests[tags[questData.shortTag]] or "", questData.group > 0 and questData.group or "", questData.daily and (questData.shortTag ~= DAILY and prdb.quests[tags[DAILY]]))
		else
			tomQuest2.quests[uid].tag = ""
		end
	end
	tomQuest2.cbh:Fire("updateQuestsTracker")
end

------------------------
--- QUEST_LOG_UPDATE ---
------------------------
function tomQuest2:QUEST_LOG_UPDATE(event)
	if (not event or event ~= "FORCED") and questLogUpdatePending then return end
	questLogUpdatePending = false
	questLogNeedUpdate = false
	for i in pairs(tomQuest2.questsIdToUid) do tomQuest2.questsIdToUid[i] = nil end
	for i in pairs(tomQuest2.questsTitleToUid) do tomQuest2.questsTitleToUid[i] = nil end
	local selectionId = GetQuestLogSelection()
	local timeStamp = GetTime()
	tomQuest2.numCompletedQuests = 0
	tomQuest2.numEntries, tomQuest2.numQuests = GetNumQuestLogEntries()
	tomQuest2.numCompletedDailyQuests = GetDailyQuestsCompleted()
	if tomQuest2.numEntries > 0 then
		local zone
		for id = 1, tomQuest2.numEntries do
			local title, level, tag, group, header, collapsed, completed, daily = GetQuestLogTitle(id)
			if header then
				zone = title
				if collapsed then
					collapsedHeader[zone] = true
				elseif collapsedHeader[zone] then
					collapsedHeader[zone] = nil
				end
				if not tomQuest2.questsByZone[zone] then
					tomQuest2:addZone(zone)
				end
			else
				local uid = tonumber(match(GetQuestLink(id), 'quest:(%d+)'))
				tomQuest2.questsIdToUid[id] = uid
				tomQuest2.questsTitleToUid[title] = uid
				if not tomQuest2.quests[uid] or (tomQuest2.quests[uid] and not tomQuest2.quests[uid].complete[tomQuest2.playerName]) then
					local numObjectives = tomQuest2.quests[uid] and tomQuest2.quests[uid].numObjectives or GetNumQuestLeaderBoards(id)
					tomQuest2:addQuest(tomQuest2.playerName, firstRun, uid, title, level or 0, tag or "", group or 0, daily or 0, numObjectives or 0, completed or 0, zone, id)
					tomQuest2.quests[uid].id = id
				else
					tomQuest2.quests[uid].id = id
					if tomQuest2.quests[uid].complete[tomQuest2.playerName] ~= completed then
						if completed == 1 then
							tomQuest2:questComplete(tomQuest2.playerName, firstRun, uid)
							tomQuest2.numCompletedQuests = tomQuest2.numCompletedQuests + 1
						elseif completed == -1 then
							tomQuest2:questFailed(tomQuest2.playerName, firstRun, uid)
						end
					elseif completed == 1 then
						tomQuest2.numCompletedQuests = tomQuest2.numCompletedQuests + 1
					end
				end
				local started = 0
				local numObjectivesOK = 0
				if tomQuest2.quests[uid].numObjectives > 0 then
					for objective = 1, tomQuest2.quests[uid].numObjectives do
						local need, got, nNeed, nGot, desc
						local description, qType, done = GetQuestLogLeaderBoard(objective, id)
						local unknownQT = false
						if qType == "item" or qType == "object" then
							qType = "object"
							desc, got, need = description:match(objectsPattern)
							nNeed, nGot = tonumber(need), tonumber(got)
						elseif qType == "player" then
							desc, got, need = pkstring, description:match(playersPattern)
							nNeed, nGot = tonumber(need), tonumber(got)
						elseif qType == "monster" then
							desc, got, need = description:match(monstersPattern)
							if desc == nil or got == nil or need == nil then
								desc, got, need = description:match(objectsPattern)
							end
							nNeed, nGot = tonumber(need), tonumber(got)
						elseif qType == "reputation" then
							desc, got, need = description:match(factionPattern)
							nNeed, nGot = reactions[need], reactions[got]
						elseif qType == "event" then
							 desc = description
							 got = done and 1 or 0
							 need = 1
							 nNeed, nGot = need, got
						else
							tomQuest2:Print("Quest objective type unknown please report to Gagou on the WowAce, WowInterface or in game on the EU Drek'Thar Server")
							tomQuest2:Print(qType)
							tomQuest2:Print(description)
							unknownQT = true
						end
						if not desc or strtrim(desc) == "" then
							questLogNeedUpdate = true
							questLogUpdatePending = true
						elseif not unknownQT then
							numObjectivesOK = numObjectivesOK + 1
							if not tomQuest2.questsObjectives[uid][objective] or not tomQuest2.questsObjectives[uid][objective].got[tomQuest2.playerName] then
								tomQuest2:addQuestObjective(tomQuest2.playerName, firstRun, uid, objective, desc, qType, got, need, nGot, nNeed)
								if nGot ~= 0 then
									started = 1
								end
							elseif tomQuest2.questsObjectives[uid][objective].got[tomQuest2.playerName] then
								local _, oldNGot = tomQuest2.questsObjectives[uid][objective].got[tomQuest2.playerName]:match("^(.-)~(%d-)$")
								oldNGot = tonumber(oldNGot)
								if oldNGot ~= nGot then
									tomQuest2:questObjectiveProgress(tomQuest2.playerName, firstRun, uid, objective, got, nGot)
								end
							end
						end
					end
				end
				tomQuest2.quests[uid].timeStamp = timeStamp
				if tomQuest2.quests[uid].numObjectives == numObjectivesOK then
					addQuestDetails(uid)
					if not tomQuest2.quests[uid].sync then
						tomQuest2.quests[uid].sync = true
						tomQuest2.cbh:Fire("endPlayerQuest", firstRun, "r", uid, started)
					end
				end
			end
		end
	end
	if GetQuestLogSelection() ~= selectionId then
		SelectQuestLogEntry(selectionId)
	end
	if not firstRun then
		if questLogNeedUpdate then
			tomQuest2:ScheduleTimer("QUEST_LOG_UPDATE", 0.1, "FORCED")
		end
		for uid, qData in pairs(tomQuest2.quests) do
			if qData.complete[tomQuest2.playerName] and qData.timeStamp ~= timeStamp and not collapsedHeader[qData.zone] then
				tomQuest2:questLost(tomQuest2.playerName, false, uid, abandoning, 0)
			elseif qData.complete[tomQuest2.playerName] and qData.timeStamp ~= timeStamp and collapsedHeader[qData.zone] then
				tomQuest2.quests[uid].id = nil
			end
		end
	else
		if questLogNeedUpdate then
			tomQuest2:ScheduleTimer("QUEST_LOG_UPDATE", 0.1, "FORCED")
		else
			tomQuest2.cbh:Fire("initQuestsTracker")
			tomQuest2.cbh:Fire("initParty")
			firstRun = false
			tomQuest2:updateBag()
			self:RegisterBucketEvent("BAG_UPDATE", 1, "updateBag")
		end
	end
	tomQuest2.cbh:Fire("questLogUpdated", true, true)
	abandoning = nil
end

-----------------------
--- PLAYER_LEVEL_UP ---
-----------------------
function tomQuest2:PLAYER_LEVEL_UP(event, newPlayerLevel)
	tomQuest2.playerLevel = newPlayerLevel
	for zone, zData in pairs(tomQuest2.questsByZone) do
		if zData.minLevel ~= 0 then
			local r, g, b = LibTourist:GetLevelColor(zone)
			tomQuest2.questsByZone[zone].color = format("%02x%02x%02x", r*255, g*255, b*255)
		end
	end
	for uid, qData in pairs(tomQuest2.quests) do
		local qc = getDifficultyColor(qData.level - tomQuest2.playerLevel)
		tomQuest2.quests[uid].color = format("%02x%02x%02x", qc.r*255, qc.g*255, qc.b*255)
	end
	tomQuest2.cbh:Fire("questLogUpdated", false, true)
	tomQuest2.cbh:Fire("questsWeightedLevelUpdated")
end

------------------
--- BAG_UPDATE ---
------------------
local function searchInTooltip(item, pattern)
	if item then
		scanTooltipTQ2:ClearLines()
		scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")
		scanTooltipTQ2:SetHyperlink(item)
		scanTooltipTQ2:Show()
		for i= 2, 4 do
			local text = _G["scanTooltipTQ2TextLeft"..i]:GetText() or ""
			if text == pattern then
				scanTooltipTQ2:Hide()
				return true
			end
		end
		scanTooltipTQ2:Hide()
	end
	return false
end

local function analyseItem(item, batch)
	if not items[item] then
		local itemName, _, itemRarity, _, _, itemType, _, _, _, itemTexture = GetItemInfo(item)
		local color = rarityColor[itemRarity]
		local itemSpell = GetItemSpell(item)
		if itemType == LC["Quest"] then
			if itemSpell or searchInTooltip(item, ITEM_SPELL_TRIGGER_ONUSE) then
				for uid, qData in pairs (tomQuest2.quests) do
					if qData.complete[tomQuest2.playerName] and ((qData.objective and qData.objective:find(itemName, 1, true)) or (qData.description and qData.description:find(itemName, 1, true))) then
						items[item] = uid
						tomQuest2.quests[uid].specialItemLink, tomQuest2.quests[uid].specialItemIcon = item, itemTexture
						return true
					end
				end
				items[item] = -1
				tomQuest2.usableQuestItems[item] = new()
				tomQuest2.usableQuestItems[item].icon, tomQuest2.usableQuestItems[item].color, tomQuest2.usableQuestItems[item].name = itemTexture, color, itemName
				tomQuest2.numUsableQuestItems = tomQuest2.numUsableQuestItems + 1
				return true
			elseif searchInTooltip(item, ITEM_STARTS_QUEST) then
				items[item] = 0
				tomQuest2.itemStartingQuest[item] = new()
				tomQuest2.itemStartingQuest[item].icon, tomQuest2.itemStartingQuest[item].color, tomQuest2.itemStartingQuest[item].name = itemTexture, color, itemName
				tomQuest2.numItemsStartingQuest = tomQuest2.numItemsStartingQuest + 1
				tomQuest2.cbh:Fire("itemStartingQuestLooted", item, batch)
				return true
			end
		elseif searchInTooltip(item, ITEM_STARTS_QUEST) then
			items[item] = 0
			tomQuest2.itemStartingQuest[item] = new()
			tomQuest2.itemStartingQuest[item].icon, tomQuest2.itemStartingQuest[item].color, tomQuest2.itemStartingQuest[item].name = itemTexture, color, itemName
			tomQuest2.numItemsStartingQuest = tomQuest2.numItemsStartingQuest + 1
			tomQuest2.cbh:Fire("itemStartingQuestLooted", item, batch)
			return true
		else
			items[item] = -2
			return false
		end
	elseif items[item] == -1 then
		local itemName, _, itemRarity, _, _, itemType, _, _, _, itemTexture = GetItemInfo(item)
		for uid, qData in pairs (tomQuest2.quests) do
			if qData.complete[tomQuest2.playerName] and ((qData.objective and qData.objective:find(itemName, 1, true)) or (qData.description and qData.description:find(itemName, 1, true))) then
				items[item] = uid
				tomQuest2.quests[uid].specialItemLink, tomQuest2.quests[uid].specialItemIcon = item, itemTexture
				tomQuest2.numUsableQuestItems = tomQuest2.numUsableQuestItems - 1
				tomQuest2.usableQuestItems[item] = del(tomQuest2.usableQuestItems[item])
				return true
			end
		end
	else
		return false
	end
end

function tomQuest2:updateBag(bagChanged)
	local timeStamp = GetTime()
	local updateQuestsTracker = nil
	for bag = 0, 4 do
		for slot = 1, GetContainerNumSlots(bag) do
			local item = GetContainerItemLink(bag, slot)
			if item then
				itemsTimeStamp[item] = timeStamp
				local update = analyseItem(item, true)
				if update then updateQuestsTracker = true end
			end
		end
	end
	for slotId in pairs(inventorySlotId) do
		local item = GetInventoryItemLink("player", slotId)
		if item then
			itemsTimeStamp[item] = timeStamp
			local update = analyseItem(item, false)
			if update then updateQuestsTracker = true end
		end
	end
	for item in pairs(itemsTimeStamp) do
		if itemsTimeStamp[item] ~= timeStamp then
			itemsTimeStamp[item] = nil
			if items[item] then
				if items[item] == 0 then
					tomQuest2.itemStartingQuest[item] = del(tomQuest2.itemStartingQuest[item])
					tomQuest2.numItemsStartingQuest = tomQuest2.numItemsStartingQuest - 1
					updateQuestsTracker = true
					items[item] = nil
				elseif items[item] == -1 then
					tomQuest2.usableQuestItems[item] = del(tomQuest2.usableQuestItems[item])
					tomQuest2.numUsableQuestItems = tomQuest2.numUsableQuestItems - 1
					updateQuestsTracker = true
					items[item] = nil
				elseif items[item] == -2 then
					items[item] = nil
				end
			end
			if currentItemMacro == item then
				tomQuest2:generateSpecialItemMacro()
			end
		end
	end
	if updateQuestsTracker then
		tomQuest2.cbh:Fire("updateQuestsTracker")
	end
end

----------------
--- inCombat ---
----------------
function tomQuest2:inCombat()
	if UnitAffectingCombat("player") then
		tomQuest2.cbh:Fire("inCombat")
	else
		tomQuest2.cbh:Fire("outOfCombat")
	end
end

--------------------------------
--- displayQuestInformations ---
--------------------------------
function tomQuest2:displayQuestInformations(uid)
	if prdb.modules["informations"] then
		tomQuest2.cbh:Fire("displayQuestInformations", uid)
	elseif not prdb.modules["informations"] and tomQuest2.quests[uid] and tomQuest2.quests[uid].id then
		if QuestLogFrame:IsVisible() then
			if GetQuestLogSelection() == tomQuest2.quests[uid].id then
				return HideUIPanel(QuestLogFrame)
			end
		else
			ShowUIPanel(QuestLogFrame)
		end
		if (tomQuest2.numEntries > QUESTS_DISPLAYED) then
			if (tomQuest2.quests[uid].id <= tomQuest2.numEntries - QUESTS_DISPLAYED) then
				FauxScrollFrame_SetOffset(QuestLogListScrollFrame, tomQuest2.quests[uid].id - 1)
				QuestLogListScrollFrameScrollBar:SetValue((tomQuest2.quests[uid].id - 1) * QUESTLOG_QUEST_HEIGHT)
			else
				FauxScrollFrame_SetOffset(QuestLogListScrollFrame, tomQuest2.numEntries - QUESTS_DISPLAYED)
				QuestLogListScrollFrameScrollBar:SetValue((tomQuest2.numEntries - QUESTS_DISPLAYED) * QUESTLOG_QUEST_HEIGHT)
			end
		end
		SelectQuestLogEntry(tomQuest2.quests[uid].id)
		QuestLog_SetSelection(tomQuest2.quests[uid].id)
		_G["QuestLogTitle"..(tomQuest2.quests[uid].id - FauxScrollFrame_GetOffset(QuestLogListScrollFrame))]:Click()
	end
end

------------------------
--- Macro Generation ---
------------------------
function tomQuest2:generateSpecialItemMacro(uid, item)
	if uid and tomQuest2.quests[uid].id and tomQuest2.quests[uid].specialItemLink then
		currentUidMacro = uid
		currentItemMacro = nil
		if InCombatLockdown() then return end
		local found, _, itemString = find(tomQuest2.quests[uid].specialItemLink, "^|c%x+|H(.+)|h%[.*%]")
		local index = GetMacroIndexByName("tomQuest2_SI")
		if index == 0 then
			index = CreateMacro("tomQuest2_SI", 1, "#showtooltip\n/use "..itemString, 0)
			PickupMacro(index)
		else
			EditMacro(index, "tomQuest2_SI", 1, "#showtooltip\n/use "..itemString)
		end
	elseif item and items[item] then
		currentUidMacro = nil
		currentItemMacro = item
		if InCombatLockdown() then return end
		local found, _, itemString = find(item, "^|c%x+|H(.+)|h%[.*%]")
		local index = GetMacroIndexByName("tomQuest2_SI")
		if index == 0 then
			index = CreateMacro("tomQuest2_SI", 1, "#showtooltip\n/use "..itemString, 0)
			PickupMacro(index)
		else
			EditMacro(index, "tomQuest2_SI", 1, "#showtooltip\n/use "..itemString)
		end
	elseif not uid and not item then
		currentUidMacro = nil
		currentItemMacro = nil
		local index = GetMacroIndexByName("tomQuest2_SI")
		if index == 0 then
			index = CreateMacro("tomQuest2_SI", 1, "", 0)
			PickupMacro(index)
		else
			EditMacro(index, "tomQuest2_SI", 1, "")
		end
	end
end

---------------------
--- toggle Module ---
---------------------
function tomQuest2:toggleAnnounce()
	if tomQuest2:getModuleEnabled("announce") then
		tomQuest2:setModuleEnabled("announce", false)
		tomQuest2:Print(LC["Announcement module is now Disabled"])
	else
		tomQuest2:setModuleEnabled("announce", true)
		tomQuest2:Print(LC["Announcement module is now Enabled"])
	end
end

function tomQuest2:toggleSyncParty()
	if tomQuest2:getModuleEnabled("syncParty") then
		tomQuest2:setModuleEnabled("syncParty", false)
		tomQuest2:Print(LC["Party synchronization module is now Disabled"])
	else
		tomQuest2:setModuleEnabled("syncParty", true)
		tomQuest2:Print(LC["Party synchronization module is now Enabled"])
	end
end

function tomQuest2:toggleQuestsTracker()
	if tomQuest2:getModuleEnabled("questsTracker") then
		tomQuest2:setModuleEnabled("questsTracker", false)
		tomQuest2:Print(LC["Quests tracking module is now Disabled"])
	else
		tomQuest2:setModuleEnabled("questsTracker", true)
		tomQuest2:Print(LC["Quests tracking module is now Enabled"])
	end
end

function tomQuest2:toggleAchievementTracker()
	if tomQuest2:getModuleEnabled("achievementTracker") then
		tomQuest2:setModuleEnabled("achievementTracker", false)
		tomQuest2:Print(LC["Achievements tracking module is now Disabled"])
	else
		tomQuest2:setModuleEnabled("achievementTracker", true)
		tomQuest2:Print(LC["Achievements tracking module is now Enabled"])
	end
end

--------------------------
--- Keybinding globals ---
--------------------------
BINDING_HEADER_TOMQUEST2 = "tomQuest2"